Option Strict On
Public Class frmSavings
  Dim Deposit As Double
  Dim Interest As Double
  Dim Months As Double
  Dim Final As Double

  Private Sub btnCalculate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCalculate.Click
    Dim IntRate As Double
    Dim FinalCompute As Double, IntChange As Double, IntDirection As Integer
    'Read values from text boxes
    Deposit = Val(txtDeposit.Text)
    Interest = Val(txtInterest.Text)
    IntRate = Interest / 1200
    Months = Val(txtMonths.Text)
    Final = Val(txtFinal.Text)
    'Determine which box is blank
    'Compute that missing value and put in text box
    If Trim(txtDeposit.Text) = "" Then
      'Deposit missing
      If Interest = 0 Then
        Deposit = Final / Months
      Else
        Deposit = Final / (((1 + IntRate) ^ Months - 1) / IntRate)
      End If
      txtDeposit.Text = Format(Deposit, "0.00")
    ElseIf Trim(txtInterest.Text) = "" Then
      'Interest missing - requires iterative solution
      'IntChange is how much we change interest each step
      'IntDirection is direction (+ or -) we change interest
      Interest = 0
      IntChange = 1
      IntDirection = 1
      Do
        Interest += IntDirection * IntChange
        IntRate = Interest / 1200
        FinalCompute = Deposit * ((1 + IntRate) ^ Months - 1) / IntRate
        If IntDirection = 1 Then
          If FinalCompute > Final Then
            IntDirection = -1
            IntChange /= 10
          End If
        Else
          If FinalCompute < Final Then
            IntDirection = 1
            IntChange /= 10
          End If
        End If
      Loop Until Math.Abs(FinalCompute - Final) < 0.005
      txtInterest.Text = Format(Interest, "0.00")
    ElseIf Trim(txtMonths.Text) = "" Then
      'Months missing
      If Interest = 0 Then
        Months = Final / Deposit
      Else
        Months = Math.Log(Final * IntRate / Deposit + 1) / Math.Log(1 + IntRate)
      End If
      txtMonths.Text = Format(Months, "0.00")
    ElseIf Trim(txtFinal.Text) = "" Then
      'Final value missing
      If Interest = 0 Then
        Final = Deposit * Months
      Else
        Final = Deposit * ((1 + IntRate) ^ Months - 1) / IntRate
      End If
      txtFinal.Text = Format(Final, "0.00")
    End If
  End Sub

  Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
    Me.Close()
  End Sub

  Private Sub txtDeposit_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtDeposit.KeyPress
    'only allow numbers, a single decimal point, backspace  or enter        
    Select Case e.KeyChar
      Case CChar("0") To CChar("9"), ControlChars.Back
        'acceptable keystrokes 
        e.Handled = False
      Case ControlChars.Cr
        'enter key - move to next box
        txtInterest.Focus()
        e.Handled = False
      Case CChar(".")
        'check for existence of decimal point
        If InStr(txtDeposit.Text, ".") = 0 Then
          e.Handled = False
        Else
          e.Handled = True
        End If
      Case Else
        e.Handled = True
    End Select
  End Sub

  Private Sub txtInterest_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtInterest.KeyPress
    'only allow numbers, a single decimal point, backspace  or enter        
    Select Case e.KeyChar
      Case CChar("0") To CChar("9"), ControlChars.Back
        'acceptable keystrokes 
        e.Handled = False
      Case ControlChars.Cr
        'enter key - move to next box
        txtMonths.Focus()
        e.Handled = False
      Case CChar(".")
        'check for existence of decimal point
        If InStr(txtInterest.Text, ".") = 0 Then
          e.Handled = False
        Else
          e.Handled = True
        End If
      Case Else
        e.Handled = True
    End Select
  End Sub

  Private Sub txtMonths_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtMonths.KeyPress
    'only allow numbers, backspace  or enter        
    Select Case e.KeyChar
      Case CChar("0") To CChar("9"), ControlChars.Back
        'acceptable keystrokes 
        e.Handled = False
      Case ControlChars.Cr
        'enter key - move to final deposit text box
        txtFinal.Focus()
        e.Handled = False
      Case Else
        e.Handled = True
    End Select
  End Sub

  Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
    'blank out text boxes
    txtDeposit.Text = ""
    txtInterest.Text = ""
    txtMonths.Text = ""
    txtFinal.Text = ""
    txtDeposit.Focus()
  End Sub

 
  Private Sub txtFinal_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtFinal.KeyPress
    'only allow numbers, a single decimal point, backspace  or enter        
    Select Case e.KeyChar
      Case CChar("0") To CChar("9"), ControlChars.Back
        'acceptable keystrokes 
        e.Handled = False
      Case ControlChars.Cr
        'enter key - move to calculate button
        btnCalculate.Focus()
        e.Handled = False
      Case CChar(".")
        'check for existence of decimal point
        If InStr(txtFinal.Text, ".") = 0 Then
          e.Handled = False
        Else
          e.Handled = True
        End If
      Case Else
        e.Handled = True
    End Select
  End Sub
End Class
