Public Class NumericTextBox
  Inherits System.Windows.Forms.TextBox
  Dim wDecimal As Boolean
  Dim wNegative As Boolean
  <System.ComponentModel.Category("Behavior")> Public Property HasDecimal() As Boolean
    Get
      Return (wDecimal)
    End Get
    Set(ByVal Value As Boolean)
      wDecimal = Value
    End Set
  End Property
  <System.ComponentModel.Category("Behavior")> Public Property HasNegative() As Boolean
    Get
      Return (wNegative)
    End Get
    Set(ByVal Value As Boolean)
      wNegative = Value
    End Set
  End Property
  Public Sub New()
    Me.BackColor = Color.Yellow
    Me.ForeColor = Color.Blue
    Me.Font = New Font("Arial", 10)
    Me.HasDecimal = True
    Me.HasNegative = False
  End Sub
  Private Sub NumericTextBox_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles MyBase.KeyPress
    'check pressed key
    Select Case e.KeyChar
      Case CChar("0") To CChar("9"), ControlChars.Back
        'allow numbers or backspace
        e.Handled = False
      Case CChar(".")
        'allow decimal if HasDecimal is True
        If (HasDecimal) Then
          'check if decimal already there
          If InStr(Me.Text, ".") = 0 Then
            e.Handled = False
          Else
            e.Handled = True
          End If
        Else
          e.Handled = True
        End If
      Case CChar("-")
        'allow single negative sign in first position only if HasNegative is True
        If (HasNegative) Then
          If InStr(Me.Text, "-") = 0 And Me.SelectionStart = 0 Then
            e.Handled = False
          Else
            e.Handled = True
          End If
        Else
          e.Handled = True
        End If
      Case Else
        'no other keys allowed
        e.Handled = True
    End Select
  End Sub
End Class
